Spludo Framework README
=======================

Latest Release: [![GitHub version](https://badge.fury.io/gh/DracoBlue%2Fspludo.png)](https://github.com/DracoBlue/spludo/releases)

Official Site: <https://github.com/DracoBlue/spludo>

Spludo is copyright 2009-2014 by DracoBlue <http://dracoblue.net>

What is Spludo?
----------------
Spludo is high performance, evented, server side, prototype based, javascript
mvc web framework. It includes DI+AOP and a Convention-Over-Configuration
Approach.
The framework is running on the node.JS-platform, which employs the lightning
fast V8-Engine.

New Project in 3 Steps
----------------------

1. Create the new project

        $ spludo/spludo-gen new-project

2. Enter the folder

        $ cd myapp

3. Run

 In Server Mode

        $ node run_server.js

  and open your browser at <http://localhost:8000/>

 In Console Mode

        $ node run_console.js shell.hello
        Hello, back!

Userguide
---------

This package contains a [USERGUIDE.md](USERGUIDE.md) with a big introduction into the framework.

Resources
----------

* Site: <https://github.com/DracoBlue/spludo>
* Contributing: [CONTRIBUTING.md](CONTRIBUTING.md)
* Mailing List: <http://groups.google.com/group/spludo>
* Issue Tracker: <http://github.com/DracoBlue/spludo/issues>
* User-Guide: [USERGUIDE.md](USERGUIDE.md)
* Tutorial: <https://github.com/DracoBlue/docsforit>
    1. [New Project](https://github.com/DracoBlue/docsforit/blob/master/etc/sections/new-project.md)
    2. [Base HTML Structure](https://github.com/DracoBlue/docsforit/blob/master/etc/sections/base-html-structure.md)
    3. [Markdown Views](https://github.com/DracoBlue/docsforit/blob/master/etc/sections/markdown-views.md)
    4. [Docs-Manager](https://github.com/DracoBlue/docsforit/blob/master/etc/sections/docs-manager.md)
    5. [Extending the Docs-Manager](https://github.com/DracoBlue/docsforit/blob/master/etc/sections/extending-the-docs-manager.md)
    6. [Sections-Navigation](https://github.com/DracoBlue/docsforit/blob/master/etc/sections/sections-navigation.md)
    7. [Sorting the Sections](https://github.com/DracoBlue/docsforit/blob/master/etc/sections/sorting-the-sections.md)
    8. [Configuration](https://github.com/DracoBlue/docsforit/blob/master/etc/sections/configuration.md)
    9. [Editing the Sections](https://github.com/DracoBlue/docsforit/blob/master/etc/sections/editing-the-sections.md)
    10. [Authentication](https://github.com/DracoBlue/docsforit/blob/master/etc/sections/authentication.md)

License
--------

Spludo is licensed under the terms of MIT. See LICENSE for more information.
